from microbit import *
import microbit
import os
import utime
import music

microbit.display.show(Image.HAPPY)
microbit.uart.init(baudrate=9600, bits=8, tx=pin2, rx=pin1)
i = 0
strings = ["" for i in range(256)]

def prijatie_serial():
    try:
        file8 = open("aktual.txt", "r")
        file8.read()
        file8.close()
    except:
        file8 = open("aktual.txt", "w")
        file8.write("databazaRFID\n")
        file8.close()
    file7 = open("nacitat.txt", "w")
    rcv = uart.read(12)
    file7.write(rcv + "\n")
    file7.close()
    file8.close()

def spoj():
    file1 = open("nacitat.txt", "r")
    file2 = open("aktual.txt", "r")
    file3 = open("novy.txt", "w")
    file3.write(file2.read() + file1.read())
    file1.close()
    file2.close()
    file3.close()
    file4 = open("aktual.txt", "w")
    file5 = open("novy.txt", "r")
    file4.write(file5.read())
    file4.close()
    file5.close()
    microbit.display.show(Image.GHOST)
    microbit.sleep(100)

def nachadza_sa():
    file_size = os.size("aktual.txt")
    pocet_riadkov = round((file_size / 13), 0)
    file1 = open("aktual.txt", "r")
    file2 = open("nacitat.txt", "r")
    a = 0
    for a in range(0, pocet_riadkov):
        rcv = file1.readline().rstrip("\n")
        ch = str(rcv, "utf-8")
        strings[a] = ch
    file1.close()
    rcv2 = file2.read()
    file2.close()
    ch2 = str(rcv2, "utf-8").rstrip("\n")
    for c in range(0, pocet_riadkov):
        if strings[c] == ch2:
            microbit.display.show(Image.YES)
            out = 1
            break
        else:
            microbit.display.show(Image.NO)
            out = 0
    return out

while True:
    prich_data1 = uart.any()
    if prich_data1 > 0:
        prijatie_serial()
        nach1 = nachadza_sa()
        if nach1 == 1:
            pin8.write_digital(1)
            music.pitch(440, 2000)
            pin8.write_digital(0)
            music.stop()
            microbit.display.show(Image.HAPPY)
        else:
            microbit.sleep(2000)
            microbit.display.show(Image.HAPPY)
    if microbit.button_b.is_pressed():  # prepnutie do modu prenosu suborov
        uart.init(115200)
        microbit.display.show(Image.PACMAN)
    if microbit.button_a.is_pressed():  # prepnutie do modu pridavania klucov
        microbit.display.show(Image.DIAMOND)
        x = True
        start = utime.ticks_ms()
        while x:
            prich_data2 = uart.any()
            if utime.ticks_diff(utime.ticks_ms(), start) > 10000:
                x = False
                microbit.display.show(Image.HAPPY)
                break
            if prich_data2 > 0:
                prijatie_serial()
                nach2 = nachadza_sa()
                if nach2 == 0:
                    spoj()
    microbit.sleep(100)
